@rem = ' PERL for Windows NT -- ccperl must be in search path
@echo off
@ccperl -S ccperlpp.pl %0.bat %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
@rem ';
#
#  ------------------------------------------------------------------
#  | Copyright Unpublished, Atria Software, Inc.  All Rights        |
#  | Reserved.  This software contains proprietary and confidential |
#  | information of Atria and its suppliers.  Use, disclosure or    |
#  | reproduction is prohibited without the prior express written   |
#  | consent of Atria.  Subject to RESTRICTED RIGHTS for US         |
#  | Government users.                                              |
#  ------------------------------------------------------------------
#

use File::Path;

$pname = $ARGV[0];
$version = $ARGV[1];
$leaf = $ARGV[2];
$outfile = $ARGV[3];
$tmpdir = "$ENV{'tmp'}/impget$$";

# This variable is needed to preserve the window's style pathname using
# the backslashes. It is used when calling the modified rmdir system call. 
# See defect #53820 for more details.
$rmtmpdir = "$ENV{'tmp'}\\impget$$";

while (-d "$tmpdir$i") {
    $i++;
}
$tmpdir .= $i;
$rmtmpdir .= $i;

$errh = "ssafeget.bat: \"$pname;$version\":";

mkdir($tmpdir, 0777) || die "$errh Can't create temporary directory $tmpdir $OS_ERROR($!)";
chdir($tmpdir) || die "$errh Can't change directory to $tmpdir $OS_ERROR($!)";

$line="ss get -I- -O- -W -GF- -V$version \"$pname\" 2>&1 |";
open (SS, $line) || die "$errh Could not open \"$line\" $OS_ERROR($!)";

@out = <SS>;  # Check for output
close SS;

# Any output means there was a problem
if (($out[0] =~ /does not retain old versions of itself/) ||
    ($out[0] =~ /is set to not track old versions/)) {		
    # Just exit, don't create new file.
    # This will be interpretted as no-delta case (checkin -ndata)
    chdir("..");
    rmtree $rmtmpdir;
    exit 0;
} elsif (defined($out[0])) { # anything else, just fail
    printf "ssafeget.bat: \"$pname;$version\": $out[0]";
    unlink($leaf);
    chdir("..");
    rmtree $rmtmpdir;
    exit 1;
}

# Make sure there's no temfile in the way
chmod (0777, $outfile);
unlink ($outfile);
$err="$OS_ERROR($!)";

if (-f $outfile) {
    unlink($leaf);
    chdir("..");
    rmtree $rmtmpdir;
    die "$errh $outfile exists, can't replace it $err.\n";
}


# move it into place
if (-f $leaf) {
    if (!rename ($leaf, $outfile)) {
	$err="$OS_ERROR($!)";
	unlink($leaf);
	chdir("..");
	rmtree $rmtmpdir;
	die "$errh Can't rename \"$leaf\" to \"$outfile\" $err";
    }
} else {
    unlink($leaf);
    chdir("..");
    rmtree $rmtmpdir;
    die "$errh ss get did not create $leaf as expected.\n";
}

chdir("..");
rmtree $rmtmpdir;

__END__
:endofperl
exit
